#version 120

uniform sampler2D src_tex_unit0;
uniform vec3 src_tex_size1;
varying vec2 texcoord;

void main() {
	float xp = texcoord.x;
	float hx = xp * 0.5;
	float ux = hx;
	
	float yp = texcoord.y;
	float hy = yp * 0.5;
	float uy = hy + src_tex_size1.y;
	
	float y = texture2D(src_tex_unit0, texcoord).r;
	float u = texture2D(src_tex_unit0, vec2(ux, uy)).r - 0.5;
    float v = texture2D(src_tex_unit0, vec2(ux, uy)).g - 0.5;

	y = (y - 0.5) * 1.1 + 0.5;
	
    float r = y + 1.13983 * v;
    float g = y - 0.39465 * u - 0.58060 * v;
    float b = y + 2.03211 * u;

    gl_FragColor = vec4(r, g, b, 1.0);

}
