uniform sampler2D src_tex_unit0;
uniform vec2 src_tex_size0;
varying vec2 texcoord;

void main(void)
{
	float sharp_bias = 0.5;
	float sharp_radius = 1.0;
	vec4 value;
	vec2 crd = texcoord;
	vec2 newcrd;
	float bias = -sharp_bias;
	float bias2 = bias * 1.6;
	float bias3 = bias * 0.4;
	float posbias = 1.0 + sharp_bias * 8.0;
	float p = sharp_radius / src_tex_size0.x;
	
	vec4 result = texture2D(src_tex_unit0, crd) * posbias;
	
	newcrd = vec2(crd.x - p, crd.y - p);
	result += texture2D(src_tex_unit0, newcrd) * bias2;
	newcrd = vec2(crd.x, crd.y - p);
	result += texture2D(src_tex_unit0, newcrd) * bias3;
	newcrd = vec2(crd.x + p, crd.y - p);
	result += texture2D(src_tex_unit0, newcrd) * bias2;
				
	newcrd = vec2(crd.x - p, crd.y);
	result += texture2D(src_tex_unit0, newcrd) * bias3;
	newcrd = vec2(crd.x + p, crd.y);
	result += texture2D(src_tex_unit0, newcrd) * bias3;
	
	newcrd = vec2(crd.x - p, crd.y + p);
	result += texture2D(src_tex_unit0, newcrd) * bias2;
	newcrd = vec2(crd.x, crd.y + p);
	result += texture2D(src_tex_unit0, newcrd) * bias3;
	newcrd = vec2(crd.x + p, crd.y + p);
	result += texture2D(src_tex_unit0, newcrd) * bias2;

	gl_FragColor = gl_Color * vec4(result);
}

