#version 120

uniform sampler2D src_tex_unit0;
uniform vec3 src_tex_size1;
varying vec2 texcoord;

void main() {
	float xp = texcoord.x;
	float yp = texcoord.y;
	float hx = xp * 0.5;
	float hy = yp * 0.5;
	float uy = hy + src_tex_size1.y;
	float ux = hx;
	float vx = hx + src_tex_size1.z;
	
	float y = texture2D(src_tex_unit0, vec2(xp,yp)).r;
	float u = texture2D(src_tex_unit0, vec2(ux,uy)).r - 0.5;
	float v = texture2D(src_tex_unit0, vec2(vx,uy)).r - 0.5;
	
	y = (y - 0.5) * 1.1 + 0.5;
	
	// yleisemmin mainittu muunnos
	float r = y + 1.140 * v;
	float g = y - 0.395 * u - 0.581 * v;
	float b = y + 2.032 * u;
	
	gl_FragColor = vec4(r,g,b,1.0);
}
