#version 120

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;

varying vec4 v_color;
varying vec2 texcoord;

void main() {
	float y = texture2D(texture0, texcoord).r;
	float u = texture2D(texture1, texcoord).r - 0.5;
	float v = texture2D(texture2, texcoord).r - 0.5;

	float r = y + 1.4 * v;
	float g = y - 0.2 * u - 0.3 * v;
	float b = y + 1.7 * u;

	gl_FragColor = vec4(r * v_color.r, g * v_color.g, b * v_color.b, v_color.a);
}
